#region Using declarations
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    /// <summary>
    /// </summary>
    [Description("This Indicator was built to show the Wide Range Body and Hidden Divergence as described by TheStrategyLab. It can be applied to any chart type that makes sense and will show the WRB and Hidden Gap of that chart type")]
    public class bcHiddenGapNative : Indicator
    {
        #region Variables
        // Wizard generated variables
        //    private	SolidBrush[]		brushes				= { new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black), new SolidBrush(Color.Black) };
		
			private int	linewidth	= 2;	
			private int _intCalculationIndex = 1;
			private int _intStartBar = 0;
			private bool enableAlert= true;
			private string audioFile= "Alert3.wav";
			
			private Color WRBup=Color.DeepSkyBlue;
			private Color WRBdown=Color.DarkMagenta;
			private Color hiddenGapdown=Color.Magenta;
			private Color hiddenGapup=Color.Cyan;
			private int  opaque = 5;
			
			#endregion

        /// <summary>
       /// </summary>
        protected override void Initialize()
        {
			AutoScale					= false;
			Overlay						= true;
	     }

        /// <summary>
        /// Called on each bar update event (incoming tick)
        /// </summary>
			
        protected override void OnBarUpdate()			
       {	this._intCalculationIndex = CalculateOnBarClose ? 0 : 1;
			if (CurrentBar < 5)
				return;
			{						
			#region Up Candles	
			//Wide Range Body Up+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++Up++++++++++++++++++++
				if(Close[0]>Open[0]
				&&Math.Abs(Close[0]-Open[0])>Math.Abs(Close[1]-Open[1])   //Candle Body one back is WRB?
				&&Math.Abs(Close[0]-Open[0])>Math.Abs(Close[2]-Open[2])   //WRB > Interval 1st Prior
				&&Math.Abs(Close[0]-Open[0])>Math.Abs(Close[3]-Open[3]))//WRB > Interval 2nd Prior
				{BarColor= WRBup;}
				
			//Hidden Gap Up+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++Up+++++++++++++++++++
				if (Low[0] > High[2]  //Gap from Current Candle to Candle before WRB
				&& Math.Abs(Close[1]-Open[1])>Math.Abs(Close[2]-Open[2])   //Candle Body one back is WRB?
				&&Math.Abs(Close[1]-Open[1])>Math.Abs(Close[3]-Open[3])   //WRB > Interval 1st Prior
				&&Math.Abs(Close[1]-Open[1])>Math.Abs(Close[4]-Open[4]))   //WRB > Interval 2nd Prior
				{
				DrawRectangle(CurrentBar.ToString(), false, 2, High[2] , 0, Low[0], hiddenGapup, hiddenGapup, Opacity);		
				if (enableAlert)
				{
					Alert("Alert", NinjaTrader.Cbi.Priority.High, "Alert", AudioFile, 20, hiddenGapup, Color.Black);	
				}}
				#endregion
			#region Down Candles	
				//Wide Range Body Down---------------------------------------------------------------------Down--------------------------------------------
				if(Close[0]<Open[0]
				&&Math.Abs(Close[0]-Open[0])>Math.Abs(Close[1]-Open[1])   //Candle Body one back is WRB?
				&&Math.Abs(Close[0]-Open[0])>Math.Abs(Close[2]-Open[2])   //WRB > Interval 1st Prior
				&&Math.Abs(Close[0]-Open[0])>Math.Abs(Close[3]-Open[3]))//WRB > Interval 2nd Prior
				{BarColor= WRBdown;}	
				
				//Hidden Gap Down ---------------------------------------------------------------------------Down--------------------------------------------
				if (High[0] < Low[2]   //Gap from Current Candle to Candle before WRB
				&& Math.Abs(Close[1]-Open[1])>Math.Abs(Close[2]-Open[2])  //Candle Body one back is WRB?
				&& Math.Abs(Close[1]-Open[1])>Math.Abs(Close[3]-Open[3])  //Candle Body one back is WRB? 
				&& Math.Abs(Close[1]-Open[1])>Math.Abs(Close[4]-Open[4])  //Candle Body one back is WRB?	
				)	
				{			
				DrawRectangle(CurrentBar.ToString(), false, 2, Low[2], 0, High[0] , hiddenGapdown,hiddenGapdown,Opacity);	
				if (enableAlert)
				{
					Alert("Alert", NinjaTrader.Cbi.Priority.High, "Alert",  AudioFile, 20, hiddenGapdown, Color.Black);		
				}}
			#endregion
			}
		}
			
        #region Properties       
		#region Gap Down Color
		[XmlIgnore()]
		[Category("\t\t\t\tTrigger Colors")]
		[Gui.Design.DisplayNameAttribute("\t\t\tGap Down Color")]
		public Color GapDownColor
		{
     	get { return hiddenGapdown; }
    	set { hiddenGapdown = value; }
		}
		[Browsable(false)]
		public string GapDownColorSerialize
		{
			get { return NinjaTrader.Gui.Design.SerializableColor.ToString(hiddenGapdown); }
			set {hiddenGapdown = NinjaTrader.Gui.Design.SerializableColor.FromString(value); }
		}
		#endregion
		
		#region Gap Up Color
		[XmlIgnore()]
		[Category("\t\t\t\tTrigger Colors")]
		[Gui.Design.DisplayNameAttribute("\t\t\tGap Up Color")]
		public Color GapUpColor
		{
     	get { return hiddenGapup; }
    	set { hiddenGapup = value; }
		}
		[Browsable(false)]
		public string GapUpColorSerialize
		{
			get { return NinjaTrader.Gui.Design.SerializableColor.ToString(hiddenGapup); }
			set {hiddenGapup = NinjaTrader.Gui.Design.SerializableColor.FromString(value); }
		}
		#endregion
			
		#region Gap Fill Opacity
		[XmlIgnore()]
		[Category("\t\t\t\tTrigger Colors")]
		[Gui.Design.DisplayNameAttribute("\t\t\tGap Fill Opacity")]
		public int Opacity
		{
     	get { return opaque; }
    	set { opaque = value; }
		}
		#endregion
		
		#region WRB Up Color
		[XmlIgnore()]
		[Category("\t\t\t\tTrigger Colors")]
		[Gui.Design.DisplayNameAttribute("\t\t\tWide Range Body Up Color")]
		public Color WRBUpColor
		{
     	get { return WRBup; }
    	set { WRBup = value; }
		}
		[Browsable(false)]
		public string WRBUpColorSerialize
		{
			get { return NinjaTrader.Gui.Design.SerializableColor.ToString(WRBup); }
			set { WRBup = NinjaTrader.Gui.Design.SerializableColor.FromString(value); }
		}
		#endregion
		
		#region WRB Down Color
		[XmlIgnore()]
		[Category("\t\t\t\tTrigger Colors")]
		[Gui.Design.DisplayNameAttribute("\t\t\tWide Range Body Down Color")]
		public Color WRBDownColor
		{
     	get { return WRBdown; }
    	set { WRBdown = value; }
		}
		[Browsable(false)]
		public string WRBDownColorSerialize
		{
			get { return NinjaTrader.Gui.Design.SerializableColor.ToString(WRBdown); }
			set { WRBdown = NinjaTrader.Gui.Design.SerializableColor.FromString(value); }
		}
		#endregion
		
		#region Sound Alert
		[Description("Alert On/Off")]
        [GridCategory("Parameters")]
        public bool EnableAlert
        {
           get { return enableAlert ; }
          set { enableAlert =  value; }
        }
			[Description("Alert Sound")]
        [GridCategory("Parameters")]
        public string AudioFile
        {
          get { return audioFile ; }
         set { audioFile =  value; }
        }
		#endregion
			
		#endregion
		
	}
}

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private bcHiddenGapNative[] cachebcHiddenGapNative = null;

        private static bcHiddenGapNative checkbcHiddenGapNative = new bcHiddenGapNative();

        /// <summary>
        /// This Indicator was built to show the Wide Range Body and Hidden Divergence as described by TheStrategyLab. It can be applied to any chart type that makes sense and will show the WRB and Hidden Gap of that chart type
        /// </summary>
        /// <returns></returns>
        public bcHiddenGapNative bcHiddenGapNative(string audioFile, bool enableAlert)
        {
            return bcHiddenGapNative(Input, audioFile, enableAlert);
        }

        /// <summary>
        /// This Indicator was built to show the Wide Range Body and Hidden Divergence as described by TheStrategyLab. It can be applied to any chart type that makes sense and will show the WRB and Hidden Gap of that chart type
        /// </summary>
        /// <returns></returns>
        public bcHiddenGapNative bcHiddenGapNative(Data.IDataSeries input, string audioFile, bool enableAlert)
        {
            if (cachebcHiddenGapNative != null)
                for (int idx = 0; idx < cachebcHiddenGapNative.Length; idx++)
                    if (cachebcHiddenGapNative[idx].AudioFile == audioFile && cachebcHiddenGapNative[idx].EnableAlert == enableAlert && cachebcHiddenGapNative[idx].EqualsInput(input))
                        return cachebcHiddenGapNative[idx];

            lock (checkbcHiddenGapNative)
            {
                checkbcHiddenGapNative.AudioFile = audioFile;
                audioFile = checkbcHiddenGapNative.AudioFile;
                checkbcHiddenGapNative.EnableAlert = enableAlert;
                enableAlert = checkbcHiddenGapNative.EnableAlert;

                if (cachebcHiddenGapNative != null)
                    for (int idx = 0; idx < cachebcHiddenGapNative.Length; idx++)
                        if (cachebcHiddenGapNative[idx].AudioFile == audioFile && cachebcHiddenGapNative[idx].EnableAlert == enableAlert && cachebcHiddenGapNative[idx].EqualsInput(input))
                            return cachebcHiddenGapNative[idx];

                bcHiddenGapNative indicator = new bcHiddenGapNative();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.AudioFile = audioFile;
                indicator.EnableAlert = enableAlert;
                Indicators.Add(indicator);
                indicator.SetUp();

                bcHiddenGapNative[] tmp = new bcHiddenGapNative[cachebcHiddenGapNative == null ? 1 : cachebcHiddenGapNative.Length + 1];
                if (cachebcHiddenGapNative != null)
                    cachebcHiddenGapNative.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachebcHiddenGapNative = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// This Indicator was built to show the Wide Range Body and Hidden Divergence as described by TheStrategyLab. It can be applied to any chart type that makes sense and will show the WRB and Hidden Gap of that chart type
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.bcHiddenGapNative bcHiddenGapNative(string audioFile, bool enableAlert)
        {
            return _indicator.bcHiddenGapNative(Input, audioFile, enableAlert);
        }

        /// <summary>
        /// This Indicator was built to show the Wide Range Body and Hidden Divergence as described by TheStrategyLab. It can be applied to any chart type that makes sense and will show the WRB and Hidden Gap of that chart type
        /// </summary>
        /// <returns></returns>
        public Indicator.bcHiddenGapNative bcHiddenGapNative(Data.IDataSeries input, string audioFile, bool enableAlert)
        {
            return _indicator.bcHiddenGapNative(input, audioFile, enableAlert);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// This Indicator was built to show the Wide Range Body and Hidden Divergence as described by TheStrategyLab. It can be applied to any chart type that makes sense and will show the WRB and Hidden Gap of that chart type
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.bcHiddenGapNative bcHiddenGapNative(string audioFile, bool enableAlert)
        {
            return _indicator.bcHiddenGapNative(Input, audioFile, enableAlert);
        }

        /// <summary>
        /// This Indicator was built to show the Wide Range Body and Hidden Divergence as described by TheStrategyLab. It can be applied to any chart type that makes sense and will show the WRB and Hidden Gap of that chart type
        /// </summary>
        /// <returns></returns>
        public Indicator.bcHiddenGapNative bcHiddenGapNative(Data.IDataSeries input, string audioFile, bool enableAlert)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.bcHiddenGapNative(input, audioFile, enableAlert);
        }
    }
}
#endregion
